{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,R-,S+,V+,X-}

UNIT DOSCountry;

INTERFACE

CONST
  USA          = 01;
  Netherlands  = 31;
  Belgium      = 32;
  France       = 33;
  Spain        = 34;
  Italy        = 39;
  Switzerland  = 41;
  Austria      = 43;
  Britain      = 44;
  Denmark      = 45;
  Sweden       = 46;
  Norway       = 47;
  Germany      = 49;


  FUNCTION fGetCountry: BYTE;

IMPLEMENTATION

USES
  Dos;

VAR
  Regs: Registers;

FUNCTION fGetCountry: BYTE;
TYPE
  tBuffer = RECORD   (* DOS-Puffer mit Landes-Information *)
    DateFormat: WORD;    (* Aufbau nur gltig ab DOS 3.0! *)
    Currency  : ARRAY[0..4] OF CHAR;(* Whrung            *)
    thousand  : CHAR;               (* Tausender-Trennung *)
    dummy1    : BYTE;               (* ein Null-Byte      *)
    dezimal   : CHAR;               (* Dezimal-Zeichen    *)
    dummy2    : BYTE;               (* ein Null-Byte      *)
    date      : CHAR;               (* Datum-Trennzeichen *)
    dummy3    : BYTE;               (* ein Null-Byte      *)
    time      : CHAR;               (* Zeit-Trennzeichen  *)
    dummy4    : BYTE;               (* ein Null-Byte      *)
    Curr_Form : BYTE; (* BITSET *)  (* Whrungsformat     *)
    exact     : BYTE; (* Stellen hinter dem Whrungskomma *)
    Time_Form : BYTE; (* BITSET *)  (* Zeitformat         *)
    Rout_Offs : WORD; (* Offset DOS-Zeichensatztabelle    *)
    Rout_Seg  : WORD; (* Segment DOS-Zeichensatztabelle   *)
    reserved  : ARRAY[0..11] OF BYTE; (* reserv. Bereich  *)
  END;
VAR
  vBuffer: tBuffer;
BEGIN
  WITH Regs DO BEGIN
    AH := $38;
    DS := SEG(vBuffer);
    DX := OFS(vBuffer);
    AL := 0;
    INTR($21, Regs);
    fGetCountry := BL;
  END;
END;

END.